<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="145px"
      v-loading="formLoading"
    >
    <el-form-item label="选择店铺" prop="shopId">
        <el-select
          v-model="formData.shopId"
          placeholder="选择店铺"
        >
          <el-option
            v-for="item in shopList"
            :key="item.id"
            :label="item.name"
            :value="item.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="选择标签" prop="labelId">
        <el-select
          v-model="formData.labelId"
          placeholder="选择标签"
        >
          <el-option
            v-for="item in labelList"
            :key="item.id"
            :label="item.title"
            :value="item.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="间隔时间(单位小时)" prop="interval">
        <el-input v-model="formData.interval" placeholder="请输入间隔时间单位小时" />
      </el-form-item>
      <el-form-item label="开始时间" prop="startTime">
        <el-time-picker
          v-model="formData.startTime"
          arrow-control
          placeholder="选择开始时间"
          format="HH:mm"
          value-format="HH:mm"
        />
      </el-form-item>
      <el-form-item label="结束时间" prop="endTime">
        <el-time-picker
          v-model="formData.endTime"
          arrow-control
          format="HH:mm"
          value-format="HH:mm"
          placeholder="选择结束时间"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { ShopDueRuleApi, ShopDueRuleVO } from '@/api/mall/store/shopduerule'
import * as ShopApi from '@/api/mall/store/shop'
import { ShopDueLabelApi } from '@/api/mall/store/shopduelabel'

/** 预约规则 表单 */
defineOptions({ name: 'ShopDueRuleForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  shopId: undefined,
  shopName: undefined,
  labelId: undefined,
  interval: undefined,
  startTime: undefined,
  endTime: undefined
})
const formRules = reactive({
  shopId: [{ required: true, message: '请选择店铺', trigger: 'blur' }],
  labelId: [{ required: true, message: '请选择标签', trigger: 'blur' }],
  interval: [{ required: true, message: '间隔时间不能为空', trigger: 'blur' }],
  startTime: [{ required: true, message: '开始时间不能为空', trigger: 'blur' }],
  endTime: [{ required: true, message: '结束时间不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref
const shopList = ref([])
const labelList = ref([])

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  getList()
   let data = await ShopDueLabelApi.getShopDueLabelPage()
   labelList.value = data.list
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await ShopDueRuleApi.getShopDueRule(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as ShopDueRuleVO
    if (formType.value === 'create') {
      await ShopDueRuleApi.createShopDueRule(data)
      message.success(t('common.createSuccess'))
    } else {
      await ShopDueRuleApi.updateShopDueRule(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

const getList = async () => {
  try {
    const data = await ShopApi.getShopList()
    shopList.value = data

  } finally {
    
  }
}
/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    shopId: undefined,
    shopName: undefined,
    labelId: undefined,
    interval: undefined,
    startTime: undefined,
    endTime: undefined
  }
  formRef.value?.resetFields()
}
</script>